diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
new file mode 100644
index d10fb4e..c1e74c0
*** a/src/backend/access/heap/heapam.c
--- b/src/backend/access/heap/heapam.c
*************** l2:
*** 3735,3741 ****
  				 */
  				if (xmax_infomask_changed(oldtup.t_data->t_infomask,
  										  infomask) ||
! 				!TransactionIdEquals(HeapTupleHeaderGetRawXmax(oldtup.t_data),
  									 xwait))
  					goto l2;
  			}
--- 4194,4200 ----
  				 */
  				if (xmax_infomask_changed(oldtup.t_data->t_infomask,
  										  infomask) ||
! 				!TransactionIdEquals(HeapTupleGetRawXmax(&oldtup),
  									 xwait))
  					goto l2;
  			}
*************** l2:
*** 3760,3766 ****
  			 * subxact aborts.
  			 */
  			if (!HEAP_XMAX_IS_LOCKED_ONLY(oldtup.t_data->t_infomask))
! 				update_xact = HeapTupleGetUpdateXid(oldtup.t_data);
  			else
  				update_xact = InvalidTransactionId;
  
--- 4219,4225 ----
  			 * subxact aborts.
  			 */
  			if (!HEAP_XMAX_IS_LOCKED_ONLY(oldtup.t_data->t_infomask))
! 				update_xact = HeapTupleGetUpdateXid(&oldtup);
  			else
  				update_xact = InvalidTransactionId;
  
*************** l2:
*** 3808,3813 ****
--- 4267,4274 ----
  			checked_lockers = true;
  			LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
  
+ 			HeapTupleCopyBaseFromPage(&oldtup, page);
+ 
  			/*
  			 * xwait is done, but if xwait had just locked the tuple then some
  			 * other xact could update this tuple before we get to this point.
*************** l2:
*** 3815,3821 ****
  			 */
  			if (xmax_infomask_changed(oldtup.t_data->t_infomask, infomask) ||
  				!TransactionIdEquals(xwait,
! 								   HeapTupleHeaderGetRawXmax(oldtup.t_data)))
  				goto l2;
  
  			/* Otherwise check if it committed or aborted */
--- 4276,4282 ----
  			 */
  			if (xmax_infomask_changed(oldtup.t_data->t_infomask, infomask) ||
  				!TransactionIdEquals(xwait,
! 								   HeapTupleGetRawXmax(&oldtup)))
  				goto l2;
  
  			/* Otherwise check if it committed or aborted */
*************** l2:
*** 3841,3847 ****
  			   result == HeapTupleBeingUpdated);
  		Assert(!(oldtup.t_data->t_infomask & HEAP_XMAX_INVALID));
  		hufd->ctid = oldtup.t_data->t_ctid;
! 		hufd->xmax = HeapTupleHeaderGetUpdateXid(oldtup.t_data);
  		if (result == HeapTupleSelfUpdated)
  			hufd->cmax = HeapTupleHeaderGetCmax(oldtup.t_data);
  		else
--- 4302,4308 ----
  			   result == HeapTupleBeingUpdated);
  		Assert(!(oldtup.t_data->t_infomask & HEAP_XMAX_INVALID));
  		hufd->ctid = oldtup.t_data->t_ctid;
! 		hufd->xmax = HeapTupleGetUpdateXidAny(&oldtup);
  		if (result == HeapTupleSelfUpdated)
  			hufd->cmax = HeapTupleHeaderGetCmax(oldtup.t_data);
  		else
*************** l2:
*** 3873,3878 ****
--- 4334,4340 ----
  		LockBuffer(buffer, BUFFER_LOCK_UNLOCK);
  		visibilitymap_pin(relation, block, &vmbuffer);
  		LockBuffer(buffer, BUFFER_LOCK_EXCLUSIVE);
+ 		HeapTupleCopyBaseFromPage(&oldtup, page);
  		goto l2;
  	}
  
*************** l2:
*** 3882,3888 ****
  	 * If the tuple we're updating is locked, we need to preserve the locking
  	 * info in the old tuple's Xmax.  Prepare a new Xmax value for this.
  	 */
! 	compute_new_xmax_infomask(HeapTupleHeaderGetRawXmax(oldtup.t_data),
  							  oldtup.t_data->t_infomask,
  							  oldtup.t_data->t_infomask2,
  							  xid, *lockmode, true,
--- 4344,4350 ----
  	 * If the tuple we're updating is locked, we need to preserve the locking
  	 * info in the old tuple's Xmax.  Prepare a new Xmax value for this.
  	 */
! 	compute_new_xmax_infomask(HeapTupleGetRawXmax(&oldtup),
  							  oldtup.t_data->t_infomask,
  							  oldtup.t_data->t_infomask2,
  							  xid, *lockmode, true,
*************** l2:
*** 3901,3907 ****
  		(checked_lockers && !locker_remains))
  		xmax_new_tuple = InvalidTransactionId;
  	else
! 		xmax_new_tuple = HeapTupleHeaderGetRawXmax(oldtup.t_data);
  
  	if (!TransactionIdIsValid(xmax_new_tuple))
  	{
--- 4363,4369 ----
  		(checked_lockers && !locker_remains))
  		xmax_new_tuple = InvalidTransactionId;
  	else
! 		xmax_new_tuple = HeapTupleGetRawXmax(&oldtup);
  
  	if (!TransactionIdIsValid(xmax_new_tuple))
  	{
*************** l2:
*** 3934,3950 ****
  	 */
  	newtup->t_data->t_infomask &= ~(HEAP_XACT_MASK);
  	newtup->t_data->t_infomask2 &= ~(HEAP2_XACT_MASK);
- 	HeapTupleHeaderSetXmin(newtup->t_data, xid);
  	HeapTupleHeaderSetCmin(newtup->t_data, cid);
  	newtup->t_data->t_infomask |= HEAP_UPDATED | infomask_new_tuple;
  	newtup->t_data->t_infomask2 |= infomask2_new_tuple;
! 	HeapTupleHeaderSetXmax(newtup->t_data, xmax_new_tuple);
  
  	/*
  	 * Replace cid with a combo cid if necessary.  Note that we already put
  	 * the plain cid into the new tuple.
  	 */
! 	HeapTupleHeaderAdjustCmax(oldtup.t_data, &cid, &iscombo);
  
  	/*
  	 * If the toaster needs to be activated, OR if the new tuple will not fit
--- 4396,4418 ----
  	 */
  	newtup->t_data->t_infomask &= ~(HEAP_XACT_MASK);
  	newtup->t_data->t_infomask2 &= ~(HEAP2_XACT_MASK);
  	HeapTupleHeaderSetCmin(newtup->t_data, cid);
  	newtup->t_data->t_infomask |= HEAP_UPDATED | infomask_new_tuple;
  	newtup->t_data->t_infomask2 |= infomask2_new_tuple;
! 
! 	heap_page_prepare_for_xid(relation, buffer, xid, false);
! 	HeapTupleCopyBaseFromPage(newtup, page);
! 	HeapTupleSetXmin(newtup, xid);
! 	heap_page_prepare_for_xid(relation, buffer, xmax_new_tuple,
! 		(newtup->t_data->t_infomask & HEAP_XMAX_IS_MULTI) ? true : false);
! 	HeapTupleCopyBaseFromPage(newtup, page);
! 	HeapTupleSetXmax(newtup, xmax_new_tuple);
  
  	/*
  	 * Replace cid with a combo cid if necessary.  Note that we already put
  	 * the plain cid into the new tuple.
  	 */
! 	HeapTupleHeaderAdjustCmax(&oldtup, &cid, &iscombo);
  
  	/*
  	 * If the toaster needs to be activated, OR if the new tuple will not fit
*************** l2:
*** 3998,4004 ****
  		 * to be done separately from the lock, because the potentially
  		 * created multixact would otherwise be wrong.
  		 */
! 		compute_new_xmax_infomask(HeapTupleHeaderGetRawXmax(oldtup.t_data),
  								  oldtup.t_data->t_infomask,
  								  oldtup.t_data->t_infomask2,
  								  xid, *lockmode, false,
--- 4466,4472 ----
  		 * to be done separately from the lock, because the potentially
  		 * created multixact would otherwise be wrong.
  		 */
! 		compute_new_xmax_infomask(HeapTupleGetRawXmax(&oldtup),
  								  oldtup.t_data->t_infomask,
  								  oldtup.t_data->t_infomask2,
  								  xid, *lockmode, false,
*************** l2:
*** 4007,4012 ****
--- 4475,4484 ----
  
  		Assert(HEAP_XMAX_IS_LOCKED_ONLY(infomask_lock_old_tuple));
  
+ 		heap_page_prepare_for_xid(relation, buffer, xmax_lock_old_tuple,
+ 			(infomask_lock_old_tuple & HEAP_XMAX_IS_MULTI) ? true : false);
+ 		HeapTupleCopyBaseFromPage(&oldtup, page);
+ 
  		START_CRIT_SECTION();
  
  		/* Clear obsolete visibility flags ... */
*************** l2:
*** 4015,4023 ****
  		HeapTupleClearHotUpdated(&oldtup);
  		/* ... and store info about transaction updating this tuple */
  		Assert(TransactionIdIsValid(xmax_lock_old_tuple));
- 		HeapTupleHeaderSetXmax(oldtup.t_data, xmax_lock_old_tuple);
  		oldtup.t_data->t_infomask |= infomask_lock_old_tuple;
  		oldtup.t_data->t_infomask2 |= infomask2_lock_old_tuple;
  		HeapTupleHeaderSetCmax(oldtup.t_data, cid, iscombo);
  
  		/* temporarily make it look not-updated, but locked */
--- 4487,4495 ----
  		HeapTupleClearHotUpdated(&oldtup);
  		/* ... and store info about transaction updating this tuple */
  		Assert(TransactionIdIsValid(xmax_lock_old_tuple));
  		oldtup.t_data->t_infomask |= infomask_lock_old_tuple;
  		oldtup.t_data->t_infomask2 |= infomask2_lock_old_tuple;
+ 		HeapTupleSetXmax(&oldtup, xmax_lock_old_tuple);
  		HeapTupleHeaderSetCmax(oldtup.t_data, cid, iscombo);
  
  		/* temporarily make it look not-updated, but locked */
*************** l2:
*** 4180,4185 ****
--- 4652,4663 ----
  									   bms_overlap(modified_attrs, id_attrs),
  										   &old_key_copied);
  
+ 	heap_page_prepare_for_xid(relation, newbuf, xid, false);
+ 	HeapTupleCopyBaseFromPage(heaptup, page);
+ 	heap_page_prepare_for_xid(relation, buffer, xmax_old_tuple,
+ 		(infomask_old_tuple & HEAP_XMAX_IS_MULTI) ? true : false);
+ 	HeapTupleCopyBaseFromPage(&oldtup, page);
+ 
  	/* NO EREPORT(ERROR) from here till changes are logged */
  	START_CRIT_SECTION();
  
*************** l2:
*** 4214,4230 ****
  		HeapTupleClearHeapOnly(newtup);
  	}
  
! 	RelationPutHeapTuple(relation, newbuf, heaptup, false);		/* insert new tuple */
  
  
  	/* Clear obsolete visibility flags, possibly set by ourselves above... */
  	oldtup.t_data->t_infomask &= ~(HEAP_XMAX_BITS | HEAP_MOVED);
  	oldtup.t_data->t_infomask2 &= ~HEAP_KEYS_UPDATED;
  	/* ... and store info about transaction updating this tuple */
  	Assert(TransactionIdIsValid(xmax_old_tuple));
- 	HeapTupleHeaderSetXmax(oldtup.t_data, xmax_old_tuple);
  	oldtup.t_data->t_infomask |= infomask_old_tuple;
  	oldtup.t_data->t_infomask2 |= infomask2_old_tuple;
  	HeapTupleHeaderSetCmax(oldtup.t_data, cid, iscombo);
  
  	/* record address of new tuple in t_ctid of old one */
--- 4692,4721 ----
  		HeapTupleClearHeapOnly(newtup);
  	}
  
! 	newpage = BufferGetPage(newbuf);
  
+ 	if (newbuf != buffer)
+ 	{
+ 		/* Prepare new page for xids */
+ 		heap_page_prepare_for_xid(relation, newbuf, xid, false);
+ 		HeapTupleCopyBaseFromPage(heaptup, newpage);
+ 		HeapTupleSetXmin(heaptup, xid);
+ 		heap_page_prepare_for_xid(relation, newbuf, xmax_new_tuple,
+ 			(heaptup->t_data->t_infomask & HEAP_XMAX_IS_MULTI) ? true : false);
+ 		HeapTupleCopyBaseFromPage(heaptup, newpage);
+ 		HeapTupleSetXmax(heaptup, xmax_new_tuple);
+ 	}
+ 
+ 	RelationPutHeapTuple(relation, newbuf, heaptup, false, xid);		/* insert new tuple */
  
  	/* Clear obsolete visibility flags, possibly set by ourselves above... */
  	oldtup.t_data->t_infomask &= ~(HEAP_XMAX_BITS | HEAP_MOVED);
  	oldtup.t_data->t_infomask2 &= ~HEAP_KEYS_UPDATED;
  	/* ... and store info about transaction updating this tuple */
  	Assert(TransactionIdIsValid(xmax_old_tuple));
  	oldtup.t_data->t_infomask |= infomask_old_tuple;
  	oldtup.t_data->t_infomask2 |= infomask2_old_tuple;
+ 	HeapTupleSetXmax(&oldtup, xmax_old_tuple);
  	HeapTupleHeaderSetCmax(oldtup.t_data, cid, iscombo);
  
  	/* record address of new tuple in t_ctid of old one */
*************** heap_lock_tuple(Relation relation, HeapT
*** 4580,4585 ****
--- 5071,5077 ----
  	tuple->t_tableOid = RelationGetRelid(relation);
  
  l3:
+ 	HeapTupleCopyBaseFromPage(tuple, page);
  	result = HeapTupleSatisfiesUpdate(tuple, cid, *buffer);
  
  	if (result == HeapTupleInvisible)
*************** l3:
*** 4602,4608 ****
  		ItemPointerData t_ctid;
  
  		/* must copy state data before unlocking buffer */
! 		xwait = HeapTupleHeaderGetRawXmax(tuple->t_data);
  		infomask = tuple->t_data->t_infomask;
  		infomask2 = tuple->t_data->t_infomask2;
  		ItemPointerCopy(&tuple->t_data->t_ctid, &t_ctid);
--- 5094,5100 ----
  		ItemPointerData t_ctid;
  
  		/* must copy state data before unlocking buffer */
! 		xwait = HeapTupleGetRawXmax(tuple);
  		infomask = tuple->t_data->t_infomask;
  		infomask2 = tuple->t_data->t_infomask2;
  		ItemPointerCopy(&tuple->t_data->t_ctid, &t_ctid);
*************** l3:
*** 4758,4764 ****
  				 * now need to follow the update chain to lock the new
  				 * versions.
  				 */
! 				if (!HeapTupleHeaderIsOnlyLocked(tuple->t_data) &&
  					((tuple->t_data->t_infomask2 & HEAP_KEYS_UPDATED) ||
  					 !updated))
  					goto l3;
--- 5250,5256 ----
  				 * now need to follow the update chain to lock the new
  				 * versions.
  				 */
! 				if (!HeapTupleHeaderIsOnlyLocked(tuple) &&
  					((tuple->t_data->t_infomask2 & HEAP_KEYS_UPDATED) ||
  					 !updated))
  					goto l3;
*************** l3:
*** 4814,4820 ****
  					 */
  					LockBuffer(*buffer, BUFFER_LOCK_EXCLUSIVE);
  					if (xmax_infomask_changed(tuple->t_data->t_infomask, infomask) ||
! 						!TransactionIdEquals(HeapTupleHeaderGetRawXmax(tuple->t_data),
  											 xwait))
  						goto l3;
  
--- 5306,5312 ----
  					 */
  					LockBuffer(*buffer, BUFFER_LOCK_EXCLUSIVE);
  					if (xmax_infomask_changed(tuple->t_data->t_infomask, infomask) ||
! 						!TransactionIdEquals(HeapTupleGetRawXmax(tuple),
  											 xwait))
  						goto l3;
  
*************** l3:
*** 4829,4835 ****
  				/* if the xmax changed in the meantime, start over */
  				if (xmax_infomask_changed(tuple->t_data->t_infomask, infomask) ||
  					!TransactionIdEquals(
! 									HeapTupleHeaderGetRawXmax(tuple->t_data),
  										 xwait))
  					goto l3;
  				/* otherwise, we're good */
--- 5321,5327 ----
  				/* if the xmax changed in the meantime, start over */
  				if (xmax_infomask_changed(tuple->t_data->t_infomask, infomask) ||
  					!TransactionIdEquals(
! 									HeapTupleGetRawXmax(tuple),
  										 xwait))
  					goto l3;
  				/* otherwise, we're good */
*************** l3:
*** 4855,4861 ****
  			/* ... but if the xmax changed in the meantime, start over */
  			LockBuffer(*buffer, BUFFER_LOCK_EXCLUSIVE);
  			if (xmax_infomask_changed(tuple->t_data->t_infomask, infomask) ||
! 				!TransactionIdEquals(HeapTupleHeaderGetRawXmax(tuple->t_data),
  									 xwait))
  				goto l3;
  			Assert(HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_data->t_infomask));
--- 5347,5353 ----
  			/* ... but if the xmax changed in the meantime, start over */
  			LockBuffer(*buffer, BUFFER_LOCK_EXCLUSIVE);
  			if (xmax_infomask_changed(tuple->t_data->t_infomask, infomask) ||
! 				!TransactionIdEquals(HeapTupleGetRawXmax(tuple),
  									 xwait))
  				goto l3;
  			Assert(HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_data->t_infomask));
*************** l3:
*** 5003,5009 ****
  			 * Check for xmax change, and start over if so.
  			 */
  			if (xmax_infomask_changed(tuple->t_data->t_infomask, infomask) ||
! 				!TransactionIdEquals(HeapTupleHeaderGetRawXmax(tuple->t_data),
  									 xwait))
  				goto l3;
  
--- 5495,5501 ----
  			 * Check for xmax change, and start over if so.
  			 */
  			if (xmax_infomask_changed(tuple->t_data->t_infomask, infomask) ||
! 				!TransactionIdEquals(HeapTupleGetRawXmax(tuple),
  									 xwait))
  				goto l3;
  
*************** l3:
*** 5031,5037 ****
  		if (!require_sleep ||
  			(tuple->t_data->t_infomask & HEAP_XMAX_INVALID) ||
  			HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_data->t_infomask) ||
! 			HeapTupleHeaderIsOnlyLocked(tuple->t_data))
  			result = HeapTupleMayBeUpdated;
  		else
  			result = HeapTupleUpdated;
--- 5523,5529 ----
  		if (!require_sleep ||
  			(tuple->t_data->t_infomask & HEAP_XMAX_INVALID) ||
  			HEAP_XMAX_IS_LOCKED_ONLY(tuple->t_data->t_infomask) ||
! 			HeapTupleHeaderIsOnlyLocked(tuple))
  			result = HeapTupleMayBeUpdated;
  		else
  			result = HeapTupleUpdated;
*************** failed:
*** 5044,5050 ****
  			   result == HeapTupleWouldBlock);
  		Assert(!(tuple->t_data->t_infomask & HEAP_XMAX_INVALID));
  		hufd->ctid = tuple->t_data->t_ctid;
! 		hufd->xmax = HeapTupleHeaderGetUpdateXid(tuple->t_data);
  		if (result == HeapTupleSelfUpdated)
  			hufd->cmax = HeapTupleHeaderGetCmax(tuple->t_data);
  		else
--- 5536,5542 ----
  			   result == HeapTupleWouldBlock);
  		Assert(!(tuple->t_data->t_infomask & HEAP_XMAX_INVALID));
  		hufd->ctid = tuple->t_data->t_ctid;
! 		hufd->xmax = HeapTupleGetUpdateXidAny(tuple);
  		if (result == HeapTupleSelfUpdated)
  			hufd->cmax = HeapTupleHeaderGetCmax(tuple->t_data);
  		else
*************** failed:
*** 5069,5075 ****
  		goto l3;
  	}
  
! 	xmax = HeapTupleHeaderGetRawXmax(tuple->t_data);
  	old_infomask = tuple->t_data->t_infomask;
  
  	/*
--- 5561,5567 ----
  		goto l3;
  	}
  
! 	xmax = HeapTupleGetRawXmax(tuple);
  	old_infomask = tuple->t_data->t_infomask;
  
  	/*
*************** failed:
*** 5091,5096 ****
--- 5583,5592 ----
  							  GetCurrentTransactionId(), mode, false,
  							  &xid, &new_infomask, &new_infomask2);
  
+ 	heap_page_prepare_for_xid(relation, *buffer, xid,
+ 		(new_infomask & HEAP_XMAX_IS_MULTI) ? true : false);
+ 	HeapTupleCopyBaseFromPage(tuple, page);
+ 
  	START_CRIT_SECTION();
  
  	/*
*************** failed:
*** 5109,5115 ****
  	tuple->t_data->t_infomask2 |= new_infomask2;
  	if (HEAP_XMAX_IS_LOCKED_ONLY(new_infomask))
  		HeapTupleHeaderClearHotUpdated(tuple->t_data);
! 	HeapTupleHeaderSetXmax(tuple->t_data, xid);
  
  	/*
  	 * Make sure there is no forward chain link in t_ctid.  Note that in the
--- 5605,5611 ----
  	tuple->t_data->t_infomask2 |= new_infomask2;
  	if (HEAP_XMAX_IS_LOCKED_ONLY(new_infomask))
  		HeapTupleHeaderClearHotUpdated(tuple->t_data);
! 	HeapTupleSetXmax(tuple, xid);
  
  	/*
  	 * Make sure there is no forward chain link in t_ctid.  Note that in the
*************** l5:
*** 5425,5431 ****
  				 * TransactionIdIsInProgress() should have returned false.  We
  				 * assume it's no longer locked in this case.
  				 */
! 				elog(WARNING, "LOCK_ONLY found for Xid in progress %u", xmax);
  				old_infomask |= HEAP_XMAX_INVALID;
  				old_infomask &= ~HEAP_XMAX_LOCK_ONLY;
  				goto l5;
--- 5921,5927 ----
  				 * TransactionIdIsInProgress() should have returned false.  We
  				 * assume it's no longer locked in this case.
  				 */
! 				elog(WARNING, "LOCK_ONLY found for Xid in progress " XID_FMT, xmax);
  				old_infomask |= HEAP_XMAX_INVALID;
  				old_infomask &= ~HEAP_XMAX_LOCK_ONLY;
  				goto l5;
*************** l4:
*** 5689,5695 ****
  		 * end of the chain, we're done, so return success.
  		 */
  		if (TransactionIdIsValid(priorXmax) &&
! 			!TransactionIdEquals(HeapTupleHeaderGetXmin(mytup.t_data),
  								 priorXmax))
  		{
  			result = HeapTupleMayBeUpdated;
--- 6185,6191 ----
  		 * end of the chain, we're done, so return success.
  		 */
  		if (TransactionIdIsValid(priorXmax) &&
! 			!TransactionIdEquals(HeapTupleGetXmin(&mytup),
  								 priorXmax))
  		{
  			result = HeapTupleMayBeUpdated;
*************** l4:
*** 5701,5707 ****
  		 * (sub)transaction, then we already locked the last live one in the
  		 * chain, thus we're done, so return success.
  		 */
! 		if (TransactionIdDidAbort(HeapTupleHeaderGetXmin(mytup.t_data)))
  		{
  			UnlockReleaseBuffer(buf);
  			return HeapTupleMayBeUpdated;
--- 6197,6203 ----
  		 * (sub)transaction, then we already locked the last live one in the
  		 * chain, thus we're done, so return success.
  		 */
! 		if (TransactionIdDidAbort(HeapTupleGetXmin(&mytup)))
  		{
  			UnlockReleaseBuffer(buf);
  			return HeapTupleMayBeUpdated;
*************** l4:
*** 5709,5715 ****
  
  		old_infomask = mytup.t_data->t_infomask;
  		old_infomask2 = mytup.t_data->t_infomask2;
! 		xmax = HeapTupleHeaderGetRawXmax(mytup.t_data);
  
  		/*
  		 * If this tuple version has been updated or locked by some concurrent
--- 6205,6211 ----
  
  		old_infomask = mytup.t_data->t_infomask;
  		old_infomask2 = mytup.t_data->t_infomask2;
! 		xmax = HeapTupleGetRawXmax(&mytup);
  
  		/*
  		 * If this tuple version has been updated or locked by some concurrent
*************** l4:
*** 5722,5728 ****
  			TransactionId rawxmax;
  			bool		needwait;
  
! 			rawxmax = HeapTupleHeaderGetRawXmax(mytup.t_data);
  			if (old_infomask & HEAP_XMAX_IS_MULTI)
  			{
  				int			nmembers;
--- 6218,6224 ----
  			TransactionId rawxmax;
  			bool		needwait;
  
! 			rawxmax = HeapTupleGetRawXmax(&mytup);
  			if (old_infomask & HEAP_XMAX_IS_MULTI)
  			{
  				int			nmembers;
*************** l4:
*** 5832,5845 ****
  								VISIBILITYMAP_ALL_FROZEN))
  			cleared_all_frozen = true;
  
  		START_CRIT_SECTION();
  
  		/* ... and set them */
- 		HeapTupleHeaderSetXmax(mytup.t_data, new_xmax);
  		mytup.t_data->t_infomask &= ~HEAP_XMAX_BITS;
  		mytup.t_data->t_infomask2 &= ~HEAP_KEYS_UPDATED;
  		mytup.t_data->t_infomask |= new_infomask;
  		mytup.t_data->t_infomask2 |= new_infomask2;
  
  		MarkBufferDirty(buf);
  
--- 6328,6345 ----
  								VISIBILITYMAP_ALL_FROZEN))
  			cleared_all_frozen = true;
  
+ 		heap_page_prepare_for_xid(rel, buf, new_xmax,
+ 			(new_infomask & HEAP_XMAX_IS_MULTI) ? true : false);
+ 		HeapTupleCopyBaseFromPage(&mytup, BufferGetPage(buf));
+ 
  		START_CRIT_SECTION();
  
  		/* ... and set them */
  		mytup.t_data->t_infomask &= ~HEAP_XMAX_BITS;
  		mytup.t_data->t_infomask2 &= ~HEAP_KEYS_UPDATED;
  		mytup.t_data->t_infomask |= new_infomask;
  		mytup.t_data->t_infomask2 |= new_infomask2;
+ 		HeapTupleSetXmax(&mytup, new_xmax);
  
  		MarkBufferDirty(buf);
  
*************** l4:
*** 5871,5884 ****
  		/* if we find the end of update chain, we're done. */
  		if (mytup.t_data->t_infomask & HEAP_XMAX_INVALID ||
  			ItemPointerEquals(&mytup.t_self, &mytup.t_data->t_ctid) ||
! 			HeapTupleHeaderIsOnlyLocked(mytup.t_data))
  		{
  			result = HeapTupleMayBeUpdated;
  			goto out_locked;
  		}
  
  		/* tail recursion */
! 		priorXmax = HeapTupleHeaderGetUpdateXid(mytup.t_data);
  		ItemPointerCopy(&(mytup.t_data->t_ctid), &tupid);
  		UnlockReleaseBuffer(buf);
  		if (vmbuffer != InvalidBuffer)
--- 6371,6384 ----
  		/* if we find the end of update chain, we're done. */
  		if (mytup.t_data->t_infomask & HEAP_XMAX_INVALID ||
  			ItemPointerEquals(&mytup.t_self, &mytup.t_data->t_ctid) ||
! 			HeapTupleHeaderIsOnlyLocked(&mytup))
  		{
  			result = HeapTupleMayBeUpdated;
  			goto out_locked;
  		}
  
  		/* tail recursion */
! 		priorXmax = HeapTupleGetUpdateXidAny(&mytup);
  		ItemPointerCopy(&(mytup.t_data->t_ctid), &tupid);
  		UnlockReleaseBuffer(buf);
  		if (vmbuffer != InvalidBuffer)
*************** heap_abort_speculative(Relation relation
*** 6082,6093 ****
  	tp.t_data = (HeapTupleHeader) PageGetItem(page, lp);
  	tp.t_len = ItemIdGetLength(lp);
  	tp.t_self = *tid;
  
  	/*
  	 * Sanity check that the tuple really is a speculatively inserted tuple,
  	 * inserted by us.
  	 */
! 	if (tp.t_data->t_choice.t_heap.t_xmin != xid)
  		elog(ERROR, "attempted to kill a tuple inserted by another transaction");
  	if (!(IsToastRelation(relation) || HeapTupleHeaderIsSpeculative(tp.t_data)))
  		elog(ERROR, "attempted to kill a non-speculative tuple");
--- 6582,6594 ----
  	tp.t_data = (HeapTupleHeader) PageGetItem(page, lp);
  	tp.t_len = ItemIdGetLength(lp);
  	tp.t_self = *tid;
+ 	HeapTupleCopyBaseFromPage(&tp, page);
  
  	/*
  	 * Sanity check that the tuple really is a speculatively inserted tuple,
  	 * inserted by us.
  	 */
! 	if (HeapTupleGetRawXmin(&tp) != xid)
  		elog(ERROR, "attempted to kill a tuple inserted by another transaction");
  	if (!(IsToastRelation(relation) || HeapTupleHeaderIsSpeculative(tp.t_data)))
  		elog(ERROR, "attempted to kill a non-speculative tuple");
*************** heap_abort_speculative(Relation relation
*** 6119,6125 ****
  	 * tuple immediately invisible everyone.  (In particular, to any
  	 * transactions waiting on the speculative token, woken up later.)
  	 */
! 	HeapTupleHeaderSetXmin(tp.t_data, InvalidTransactionId);
  
  	/* Clear the speculative insertion token too */
  	tp.t_data->t_ctid = tp.t_self;
--- 6620,6626 ----
  	 * tuple immediately invisible everyone.  (In particular, to any
  	 * transactions waiting on the speculative token, woken up later.)
  	 */
! 	HeapTupleSetXmin(&tp, InvalidTransactionId);
  
  	/* Clear the speculative insertion token too */
  	tp.t_data->t_ctid = tp.t_self;
*************** FreezeMultiXactId(MultiXactId multi, uin
*** 6567,6588 ****
   * recovery.  We really need to remove old xids.
   */
  bool
! heap_prepare_freeze_tuple(HeapTupleHeader tuple, TransactionId cutoff_xid,
  						  TransactionId cutoff_multi,
  						  xl_heap_freeze_tuple *frz, bool *totally_frozen_p)
  {
  	bool		changed = false;
  	bool		freeze_xmax = false;
  	TransactionId xid;
  	bool		totally_frozen = true;
  
  	frz->frzflags = 0;
  	frz->t_infomask2 = tuple->t_infomask2;
  	frz->t_infomask = tuple->t_infomask;
! 	frz->xmax = HeapTupleHeaderGetRawXmax(tuple);
  
  	/* Process xmin */
! 	xid = HeapTupleHeaderGetXmin(tuple);
  	if (TransactionIdIsNormal(xid))
  	{
  		if (TransactionIdPrecedes(xid, cutoff_xid))
--- 7068,7090 ----
   * recovery.  We really need to remove old xids.
   */
  bool
! heap_prepare_freeze_tuple(HeapTuple htup, TransactionId cutoff_xid,
  						  TransactionId cutoff_multi,
  						  xl_heap_freeze_tuple *frz, bool *totally_frozen_p)
  {
  	bool		changed = false;
  	bool		freeze_xmax = false;
  	TransactionId xid;
+ 	HeapTupleHeader tuple = htup->t_data;
  	bool		totally_frozen = true;
  
  	frz->frzflags = 0;
  	frz->t_infomask2 = tuple->t_infomask2;
  	frz->t_infomask = tuple->t_infomask;
! 	frz->xmax = HeapTupleGetRawXmax(htup);
  
  	/* Process xmin */
! 	xid = HeapTupleGetXmin(htup);
  	if (TransactionIdIsNormal(xid))
  	{
  		if (TransactionIdPrecedes(xid, cutoff_xid))
*************** heap_prepare_freeze_tuple(HeapTupleHeade
*** 6603,6609 ****
  	 *
  	 * Make sure to keep heap_tuple_needs_freeze in sync with this.
  	 */
! 	xid = HeapTupleHeaderGetRawXmax(tuple);
  
  	if (tuple->t_infomask & HEAP_XMAX_IS_MULTI)
  	{
--- 7105,7111 ----
  	 *
  	 * Make sure to keep heap_tuple_needs_freeze in sync with this.
  	 */
! 	xid = HeapTupleGetRawXmax(htup);
  
  	if (tuple->t_infomask & HEAP_XMAX_IS_MULTI)
  	{
*************** heap_prepare_freeze_tuple(HeapTupleHeade
*** 6745,6753 ****
   * NB: All code in here must be safe to execute during crash recovery!
   */
  void
! heap_execute_freeze_tuple(HeapTupleHeader tuple, xl_heap_freeze_tuple *frz)
  {
! 	HeapTupleHeaderSetXmax(tuple, frz->xmax);
  
  	if (frz->frzflags & XLH_FREEZE_XVAC)
  		HeapTupleHeaderSetXvac(tuple, FrozenTransactionId);
--- 7247,7272 ----
   * NB: All code in here must be safe to execute during crash recovery!
   */
  void
! heap_execute_freeze_tuple(HeapTuple htup, xl_heap_freeze_tuple *frz)
  {
! 	HeapTupleHeader tuple = htup->t_data;
! 
! 	HeapTupleSetXmax(htup, frz->xmax);
! 
! 	if (frz->frzflags & XLH_FREEZE_XVAC)
! 		HeapTupleHeaderSetXvac(tuple, FrozenTransactionId);
! 
! 	if (frz->frzflags & XLH_INVALID_XVAC)
! 		HeapTupleHeaderSetXvac(tuple, InvalidTransactionId);
! 
! 	tuple->t_infomask = frz->t_infomask;
! 	tuple->t_infomask2 = frz->t_infomask2;
! }
! 
! void
! heap_execute_freeze_tuple_page(Page page, HeapTupleHeader tuple, xl_heap_freeze_tuple *frz)
! {
! 	HeapTupleHeaderSetXmax(page, tuple, frz->xmax);
  
  	if (frz->frzflags & XLH_FREEZE_XVAC)
  		HeapTupleHeaderSetXvac(tuple, FrozenTransactionId);
*************** heap_execute_freeze_tuple(HeapTupleHeade
*** 6766,6772 ****
   * Useful for callers like CLUSTER that perform their own WAL logging.
   */
  bool
! heap_freeze_tuple(HeapTupleHeader tuple, TransactionId cutoff_xid,
  				  TransactionId cutoff_multi)
  {
  	xl_heap_freeze_tuple frz;
--- 7285,7291 ----
   * Useful for callers like CLUSTER that perform their own WAL logging.
   */
  bool
! heap_freeze_tuple(HeapTuple tuple, TransactionId cutoff_xid,
  				  TransactionId cutoff_multi)
  {
  	xl_heap_freeze_tuple frz;
*************** MultiXactIdGetUpdateXid(TransactionId xm
*** 6927,6936 ****
   * checking the hint bits.
   */
  TransactionId
! HeapTupleGetUpdateXid(HeapTupleHeader tuple)
  {
! 	return MultiXactIdGetUpdateXid(HeapTupleHeaderGetRawXmax(tuple),
! 								   tuple->t_infomask);
  }
  
  /*
--- 7446,7455 ----
   * checking the hint bits.
   */
  TransactionId
! HeapTupleGetUpdateXid(HeapTuple tuple)
  {
! 	return MultiXactIdGetUpdateXid(HeapTupleGetRawXmax(tuple),
! 								   tuple->t_data->t_infomask);
  }
  
  /*
*************** bool
*** 7148,7159 ****
  heap_tuple_needs_eventual_freeze(HeapTupleHeader tuple)
  {
  	TransactionId xid;
  
  	/*
  	 * If xmin is a normal transaction ID, this tuple is definitely not
  	 * frozen.
  	 */
! 	xid = HeapTupleHeaderGetXmin(tuple);
  	if (TransactionIdIsNormal(xid))
  		return true;
  
--- 7667,7682 ----
  heap_tuple_needs_eventual_freeze(HeapTupleHeader tuple)
  {
  	TransactionId xid;
+ 	HeapTupleData htup;
+ 
+ 	htup.t_data = tuple;
+ 	HeapTupleSetZeroBase(&htup);
  
  	/*
  	 * If xmin is a normal transaction ID, this tuple is definitely not
  	 * frozen.
  	 */
! 	xid = HeapTupleGetXmin(&htup);
  	if (TransactionIdIsNormal(xid))
  		return true;
  
*************** heap_tuple_needs_eventual_freeze(HeapTup
*** 7164,7176 ****
  	{
  		MultiXactId multi;
  
! 		multi = HeapTupleHeaderGetRawXmax(tuple);
  		if (MultiXactIdIsValid(multi))
  			return true;
  	}
  	else
  	{
! 		xid = HeapTupleHeaderGetRawXmax(tuple);
  		if (TransactionIdIsNormal(xid))
  			return true;
  	}
--- 7687,7699 ----
  	{
  		MultiXactId multi;
  
! 		multi = HeapTupleGetRawXmax(&htup);
  		if (MultiXactIdIsValid(multi))
  			return true;
  	}
  	else
  	{
! 		xid = HeapTupleGetRawXmax(&htup);
  		if (TransactionIdIsNormal(xid))
  			return true;
  	}
*************** heap_tuple_needs_eventual_freeze(HeapTup
*** 7198,7209 ****
   * on a standby.
   */
  bool
! heap_tuple_needs_freeze(HeapTupleHeader tuple, TransactionId cutoff_xid,
  						MultiXactId cutoff_multi, Buffer buf)
  {
  	TransactionId xid;
  
! 	xid = HeapTupleHeaderGetXmin(tuple);
  	if (TransactionIdIsNormal(xid) &&
  		TransactionIdPrecedes(xid, cutoff_xid))
  		return true;
--- 7721,7733 ----
   * on a standby.
   */
  bool
! heap_tuple_needs_freeze(HeapTuple htup, TransactionId cutoff_xid,
  						MultiXactId cutoff_multi, Buffer buf)
  {
  	TransactionId xid;
+ 	HeapTupleHeader tuple = htup->t_data;
  
! 	xid = HeapTupleGetXmin(htup);
  	if (TransactionIdIsNormal(xid) &&
  		TransactionIdPrecedes(xid, cutoff_xid))
  		return true;
*************** heap_tuple_needs_freeze(HeapTupleHeader 
*** 7217,7223 ****
  	{
  		MultiXactId multi;
  
! 		multi = HeapTupleHeaderGetRawXmax(tuple);
  		if (!MultiXactIdIsValid(multi))
  		{
  			/* no xmax set, ignore */
--- 7741,7747 ----
  	{
  		MultiXactId multi;
  
! 		multi = HeapTupleGetRawXmax(htup);
  		if (!MultiXactIdIsValid(multi))
  		{
  			/* no xmax set, ignore */
*************** heap_tuple_needs_freeze(HeapTupleHeader 
*** 7252,7258 ****
  	}
  	else
  	{
! 		xid = HeapTupleHeaderGetRawXmax(tuple);
  		if (TransactionIdIsNormal(xid) &&
  			TransactionIdPrecedes(xid, cutoff_xid))
  			return true;
--- 7776,7782 ----
  	}
  	else
  	{
! 		xid = HeapTupleGetRawXmax(htup);
  		if (TransactionIdIsNormal(xid) &&
  			TransactionIdPrecedes(xid, cutoff_xid))
  			return true;
*************** heap_tuple_needs_freeze(HeapTupleHeader 
*** 7277,7290 ****
   * with queries.
   */
  void
! HeapTupleHeaderAdvanceLatestRemovedXid(HeapTupleHeader tuple,
  									   TransactionId *latestRemovedXid)
  {
! 	TransactionId xmin = HeapTupleHeaderGetXmin(tuple);
! 	TransactionId xmax = HeapTupleHeaderGetUpdateXid(tuple);
! 	TransactionId xvac = HeapTupleHeaderGetXvac(tuple);
  
! 	if (tuple->t_infomask & HEAP_MOVED)
  	{
  		if (TransactionIdPrecedes(*latestRemovedXid, xvac))
  			*latestRemovedXid = xvac;
--- 7801,7814 ----
   * with queries.
   */
  void
! HeapTupleHeaderAdvanceLatestRemovedXid(HeapTuple tuple,
  									   TransactionId *latestRemovedXid)
  {
! 	TransactionId xmin = HeapTupleGetXmin(tuple);
! 	TransactionId xmax = HeapTupleGetUpdateXidAny(tuple);
! 	TransactionId xvac = HeapTupleHeaderGetXvac(tuple->t_data);
  
! 	if (tuple->t_data->t_infomask & HEAP_MOVED)
  	{
  		if (TransactionIdPrecedes(*latestRemovedXid, xvac))
  			*latestRemovedXid = xvac;
*************** HeapTupleHeaderAdvanceLatestRemovedXid(H
*** 7298,7305 ****
  	 * This needs to work on both master and standby, where it is used to
  	 * assess btree delete records.
  	 */
! 	if (HeapTupleHeaderXminCommitted(tuple) ||
! 		(!HeapTupleHeaderXminInvalid(tuple) && TransactionIdDidCommit(xmin)))
  	{
  		if (xmax != xmin &&
  			TransactionIdFollows(xmax, *latestRemovedXid))
--- 7822,7829 ----
  	 * This needs to work on both master and standby, where it is used to
  	 * assess btree delete records.
  	 */
! 	if (HeapTupleHeaderXminCommitted(tuple->t_data) ||
! 		(!HeapTupleHeaderXminInvalid(tuple->t_data) && TransactionIdDidCommit(xmin)))
  	{
  		if (xmax != xmin &&
  			TransactionIdFollows(xmax, *latestRemovedXid))
